﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Text.RegularExpressions;

namespace lwftp
{
    class fileCleaner
    {

        protected lwsetting template;
        protected fileitems files = new fileitems();
        protected EventLog events;


        public fileCleaner(lwsetting withTemplate, EventLog withEvents)
        {
            events = withEvents;
            template = withTemplate;
        }

        public int Process()
        {

            foreach (string filename in Directory.EnumerateFiles(AppDomain.CurrentDomain.BaseDirectory.TrimEnd('\\') + '\\' + template.outputPath.TrimEnd('\\') + '\\'))
            {

                if (Regex.IsMatch(Path.GetFileName(filename), template.fileMask))
                {

                    fileitem fi = new fileitem();
                    fi.filename = Path.GetFileName(filename);
                    fi.path = filename;
                    fi.timestamp = Directory.GetCreationTime(filename);
                    files.Add(fi);

                }

            }

            files.Sort();

            if (files.Count > template.parent.maxFiles)
            {
                for (int i = 0; i != files.Count - template.parent.maxFiles; i++)
                {
                    try
                    {
                        File.Delete(files[i].path);
                    }
                    catch (Exception e)
                    {
                        events.Add(String.Format("Error on file delete {0}", e.Message));
                        return -1;
                    }

                }

            }

            // Console.ReadLine();
            return 0;
        }

    }
}
