﻿using System;
namespace lwftp
{
    class Display
    {
        private Int32 lastPercent = -1;

        public Display(string[] msg)
        {

            Console.Clear();

            foreach (string s in msg)
            {
                Console.WriteLine(s);

            }

        }

        public void RenderConsoleProgress(int percentage)
        {
            if (lastPercent != percentage)
            {

                Console.CursorVisible = false;
                ConsoleColor originalColor = Console.ForegroundColor;
                Console.ForegroundColor = ConsoleColor.Yellow;
                Console.CursorLeft = 0;
                int width = Console.WindowWidth - 1;
                int newWidth = (int)((width * percentage) / 100d);
                string progBarDone = new string('\u2590', newWidth);
                string progBarLeft = new string('\u2590', width - newWidth);
                Console.ForegroundColor = ConsoleColor.Red;
                Console.Write(progBarDone);
                Console.ForegroundColor = ConsoleColor.Gray;
                Console.Write(progBarLeft);
                Console.ForegroundColor = originalColor;
                Console.CursorVisible = true;
                lastPercent = percentage;
            }
        }


    }
}