﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;


namespace lwftp
{

    class Program
    {


        public static int processParams(string[] args, EventLog events)
        {

            if (File.Exists(AppDomain.CurrentDomain.BaseDirectory + "config.xml"))
            {
                lwsettings settings = lwsettings.fromFile(AppDomain.CurrentDomain.BaseDirectory + "config.xml");

                if (settings != null)
                {

                    //settings.toFile(AppDomain.CurrentDomain.BaseDirectory + "config.xml");

                    if (args.Length == 1)
                    {

                        lwsetting setting = settings.templates.Find(args[0]) ?? null;

                        if (setting != null)
                        {

                            fileTransfer transfer = new fileTransfer(setting, events);
                            if (transfer.Process() == 0)
                            {

                                if (settings.cleanOld)
                                {
                                    fileCleaner cleaner = new fileCleaner(setting, events);
                                    return (cleaner.Process());

                                }
                                else
                                {
                                    return 0;
                                }

                            }
                            else
                            {
                                events.addEvent("Error while file transfer!");
                                return -1;

                            }


                        }
                        else
                        {
                            events.addEvent("Template not found!");
                            return -1;
                        }

                    }
                    else
                    {
                        events.addEvent("Need for only one commandline param!");
                        return -1;
                    }


                }

                else
                {
                    events.addEvent("Config not loaded!");
                    return -1;

                }


            }
            else
            {
                events.addEvent("Config not found!");
                return -1;

            }


        }



        static int Main(string[] args)
        {
            EventLog events = new EventLog();

            if (processParams(args, events) == 0)
            {
                Console.WriteLine(Environment.NewLine + "Ready!");
                return 0;
            }
            else
            {
                Console.Clear();

                foreach (string s in events)
                {

                    Console.WriteLine(s);
                }
                return -1;
            }



        }
    }

}


